from .colors import CheckColor
from math import pi

class Shape:
    'Base class representing 2D shapes'
    
    def __init__(self,color):
        CheckColor(color)
        self.color = color
        
    def __repr__(self):
        return f'I am a {self.color} shape'

    def area(self):
        'Computes the area of this shape.'
        pass
    
    # bonus question
    def volume(self):
        return 0
    
class Rectangle(Shape):
    'Class representing a rectangle'
    
    def __init__(self,color,length,width):
        super().__init__(color)
        self.length = length
        self.width = width
        
    def __repr__(self):
        return f"{super().__repr__().replace('shape','rectangle')}, with length: {self.length}, and width: {self.width}"
    
    def area(self):
        return self.length * self.width
    
class Circle(Shape):
    'Class representing a circle'
    
    def __init__(self,color,radius):
        super().__init__(color)
        self.radius = radius
    
    def __repr__(self):
        return f"{super().__repr__().replace('shape','circle')}, with radius {self.radius}"

    def area(self):
        return pi * self.radius**2

class Square(Rectangle):
    'Class representing a square.'
    
    def __init__(self,color,side):
        super().__init__(color,side,side)
    
    def __repr__(self):
        return f"{super().__repr__().replace('rectangle','square')}, with sides of length {self.length}"